package com.company;


import java.awt.*;
import java.io.*;
import java.util.*;

public class Main extends Component {

    public static void main(String[] args) throws IOException {
        HashMap<String, Double> frameEvents = new HashMap<>();

        System.out.println("pingAvg;pingMed;pingMin;pingMax;pingStDev;" +
                "serverAvg;serverMed;serverMin;serverMax;serverStDev;" +
                "clientAvg;clientMed;clientMin;clientMax;clientStDev;" +
                "linkAvg;linkMed;linkMin;linkMax;linkStDev;" +
                "packetAvg;packetMed;packetMin;packetMax;packetStDev;" +
                "frameAgeAvg;frameAgeMed;frameAgeMin;frameAgeMax;frameAgeStDev;" +
                "frameSizeAvg;frameSizeMed;frameSizeMin;frameSizeMax;frameSizeStDev;" +
                "captureTimeAvg;captureTimeMed;captureTimeMin;captureTimeMax;captureTimeStDev;" +
                "encodeTimeAvg;encodeTimeMed;encodeTimeMin;encodeTimeMax;encodeTimeStDev;" +
                "transferTimeAvg;transferTimeMed;transferTimeMin;transferTimeMax;transferTimeStDev;" +
                "decodeTimeAvg;decodeTimeMed;decodeTimeMin;decodeTimeMax;decodeTimeStDev;" +
                "percNetworkSlow;percNetworkLost;percDecodeSlow;percDecodeCorrupt;percDroppedLate;percDroppedReset;droppedTotal;" +
                "uploadTimeAvg;uploadTimeMed;uploadTimeMin;uploadTimeMax;uploadTimeStDev;" +
                "completeTimeAvg;completeTimeMed;completeTimeMin;completeTimeMax;completeTimeStDev;");
        for (int j = 1; j <= 11; j++) { //Number of tests
            String path = "C:\\Program Files (x86)\\Steam\\streaming\\Game "+j+"\\"; //Path to files
            for (int i = 1; i <= 10; i++) { //Number of matches per test
                ArrayList<Frame> frameList = new ArrayList<Frame>();
                ArrayList<Network> networkList = new ArrayList<Network>();

                try {

                    File file = new File(path + "concatenate" + i + ".txt");
                    //creates a new file instance
                    FileReader fr = new FileReader(file);   //reads the file
                    BufferedReader br = new BufferedReader(fr);  //creates a buffering character input stream
                    String line;
                    while ((line = br.readLine()) != null) {
                        if (line.length() != 0) {
                            if (line.charAt(0) == 'N') {
                                String[] splitList = line.split(": ");

                                Double ping = Double.valueOf(splitList[2].replaceAll("[A-Z,a-z]", ""));
                                Double server = Double.valueOf(splitList[3].replaceAll("\\D+", ""));
                                Double client = Double.valueOf(splitList[4].replaceAll("\\D+", ""));
                                Double link = Double.valueOf(splitList[5].replaceAll("\\D+", ""));
                                Double packetLoss = Double.valueOf(splitList[6].replaceAll("[A-Z,a-z:%]", ""));

                                networkList.add(new Network(ping, server, client, link, packetLoss));
                            }
                            if (line.charAt(0) == 'F') {
                                String[] splitList = line.split(", ");

                                Double frameSize = Double.valueOf(splitList[1].replaceAll("[A-Z,a-z]", ""));
                                while ((line = br.readLine()) != null) {
                                    if (line.length() != 0) {
                                        if (!line.contains("total")) {
                                            String[] listForSplitting = line.split(":");
                                            Double time = Double.valueOf(listForSplitting[1].replaceAll("ms", ""));
                                            String[] eventName = listForSplitting[0].split(" ");
                                            String[] betterEventName = eventName[11].split("Event");
                                            frameEvents.put(betterEventName[1], time);
                                        }
                                        if (line.contains("total")) {
                                            splitList = line.split(",");
                                            Double frameAge = Double.valueOf(splitList[0].replaceAll("[A-Z: a-z]", ""));
                                            String[] splitList2 = splitList[1].split(" = ");
                                            String frameResult = splitList2[1];
                                            frameList.add(new Frame(frameAge, frameSize, frameResult, (HashMap<String, Double>) frameEvents.clone()));

                                            //frameEvents.clear();
                                            break;
                                        }
                                    }

                                }

                            }
                        }
                    }
                    fr.close();    //closes the stream and release the resources



                } catch (IOException e) {
                    break;
                }
                //averageFrame(frameList);
                //averageNetwork(networkList);

                String string = "";

                ArrayList<Double> pingList = new ArrayList<>();
                ArrayList<Double> serverList = new ArrayList<>();
                ArrayList<Double> clientList = new ArrayList<>();
                ArrayList<Double> linkList = new ArrayList<>();
                ArrayList<Double> packetList = new ArrayList<>();

                for (Network network : networkList) {
                    pingList.add(network.getPing());
                    serverList.add(network.getServer());
                    clientList.add(network.getClient());
                    linkList.add(network.getLink());
                    packetList.add(network.getPacketLoss());
                }

                string = stats(pingList, string);
                string = stats(serverList, string);
                string = stats(clientList, string);
                string = stats(linkList, string);
                string = stats(packetList, string);

                pingList.clear();

                ArrayList<Double> frameAgeList = new ArrayList<>();
                ArrayList<Double> frameSizeList = new ArrayList<>();
                ArrayList<Double> captureTimeList = new ArrayList<>();
                ArrayList<Double> encodeTimeList = new ArrayList<>();
                ArrayList<Double> transferTimeList = new ArrayList<>();
                ArrayList<Double> decodeTimeList = new ArrayList<>();
                ArrayList<Double> uploadTimeList = new ArrayList<>();
                ArrayList<Double> completeTimeList = new ArrayList<>();

                HashMap<String, Double> frameEventTime = new HashMap<>();

                int droppedNetworkSlow = 0;
                int droppedNetworkLost = 0;
                int droppedDecodeSlow = 0;
                int droppedDecodeCorrupt = 0;
                int droppedLate = 0;
                int droppedReset = 0;

                for (Frame frame : frameList) {
                    frameAgeList.add(frame.getFrameage());
                    frameSizeList.add(frame.getFrameSize());
                    captureTimeList.add(frame.getCaptureTime());
                    encodeTimeList.add(frame.getEncodeTime());
                    transferTimeList.add(frame.getTransferTime());
                    decodeTimeList.add(frame.getDecodeTime());
                    uploadTimeList.add(frame.getUploadTime());
                    completeTimeList.add(frame.getCompleteTime());

                    if (frame.getFrameResult().contains("NetworkSlow")) {
                        droppedNetworkSlow++;
                    } else if (frame.getFrameResult().contains("NetworkLost")) {
                        droppedNetworkLost++;
                    } else if (frame.getFrameResult().contains("DecodeSlow")) {
                        droppedDecodeSlow++;
                    } else if (frame.getFrameResult().contains("DecodeCorrupt")) {
                        droppedDecodeCorrupt++;
                    } else if (frame.getFrameResult().contains("DroppedLate")) {
                        droppedLate++;
                    } else if (frame.getFrameResult().contains("DroppedReset")) {
                        droppedReset++;
                    }
                }
            


            string = stats(frameAgeList, string);
            string = stats(frameSizeList, string);
            string = stats(captureTimeList, string);
            string = stats(encodeTimeList, string);
            string = stats(transferTimeList, string);
            string = stats(decodeTimeList, string);

            double percNSlow = droppedNetworkSlow / frameList.size();
            double percNLost = droppedNetworkLost / frameList.size();
            double percDSlow = droppedDecodeSlow / frameList.size();
            double percDcorrupt = droppedDecodeCorrupt / frameList.size();
            double percDlate = droppedLate / frameList.size();
            double percDreset = droppedReset / frameList.size();
            double droppedTotal = (droppedNetworkSlow + droppedNetworkLost + droppedDecodeSlow + droppedDecodeCorrupt + droppedLate + droppedReset) / frameList.size();

            string = string + ";" + percNSlow + ";" + percNLost + ";" + percDSlow + ";" + percDcorrupt + ";" + percDlate + ";" + percDreset + ";" + droppedTotal;

            string = stats(uploadTimeList, string);
            string = stats(completeTimeList, string);

            System.out.println(string);


            }

        }



    }


    public static String stats(ArrayList<Double> numberList, String string) {
        ArrayList<Double> list = numberList;


        list.replaceAll(t -> Objects.isNull(t) ? 0 : t);
        OptionalDouble average = list
                .stream()
                .mapToDouble(a -> a)
                .average();
        Collections.sort(list);
        Double median = list.get(Math.round(list.size() / 2));
        Double min = list.get(0);
        Double max = list.get(list.size() - 1);

        double temp = 0;

        for (Double number : list
        ) {
            // Step 2:
            double squrDiffToMean = Math.pow(number - average.getAsDouble(), 2);

            // Step 3:
            temp += squrDiffToMean;
        }

        double meanOfDiffs = (double) temp / (double) (list.size());
        double stdev = Math.sqrt(meanOfDiffs);

        if (string.length() > 0) {
            string += ";";
        }

        string = string + average.getAsDouble() + ";" + median + ";" + min + ";" + max
                + ";" + stdev;

        return string;
    }

    /*
        public static void averageFrame(ArrayList<Frame> frameList) {
            Double counter = 0.0;
            Double frameAge = 0.0;
            Double frameSize = 0.0;
            int amountFramesDropped = 0;
            int amountFramesDisplayed = 0;
            for (Frame frame : frameList) {
                frameAge += frame.getFrameage();
                frameSize += frame.getFrameSize();
                if (frame.getFrameResult().contains("Dropped")) {
                    amountFramesDropped++;
                }
                if (frame.getFrameResult().contains("Displayed")) {
                    amountFramesDisplayed++;
                }
                counter++;
            }
            Double averageFrameAge = frameAge / counter;
            Double averageFrameSize = frameSize / counter;
            Double procentDropped = amountFramesDropped / counter;

            //System.out.println("Average frameage = " + averageFrameAge + ". Average frame size = " + averageFrameSize);
            //System.out.println("Amount of frames displayed = " + amountFramesDisplayed + ". Amount of frames dropped = " + amountFramesDropped);
            //System.out.println("Procent of frames dropped = " + procentDropped);
            //System.out.println(averageFrameAge + "\t" + procentDropped);
            System.out.println(averageFrameSize);
        }

        public static void averageNetwork(ArrayList<Network> networkList) {
            Double ping = 0.0;
            Double server = 0.0;
            Double client = 0.0;
            Double link = 0.0;
            Double packetLoss = 0.0;

            int counter = 0;
            for (Network network : networkList) {
                ping += network.getPing();
                server += network.getServer();
                client += network.getClient();
                link += network.getLink();
                packetLoss += network.getPacketLoss();

                counter++;
            }
            Double avgPing = ping/counter;
            Double avgServer = server/counter;
            Double avgClient = client/counter;
            Double avgLink = link/counter;
            Double avgPacketLoss = packetLoss/counter;

            //System.out.println("Average ping: " + avgPing);
            System.out.println(avgServer);
            //System.out.println("Average client2server: " + avgClient);
            //System.out.println("Average link: " + avgLink);
            //System.out.println("Average packet loss: " + avgPacketLoss);

        }
    */



}

