#!/usr/bin/env python3
"""
Module Docstring
Moves all of the files gathered during testing to a folder.
"""
__author__ = "Your Name"
__version__ = "0.1.0"
__license__ = "MIT"

import os
from datetime import datetime
import shutil

def saveFile(desDir): 
    now = datetime.now()

    current_time = now.strftime("%H-%M-%S_%d-%b-%Y")
    src_dir=r"H:\Programs\Steam\logs\streaming_log.txt" #Source Directory
    des_dir=desDir+"\\"+str(current_time)+".txt" #Destination Directory
    shutil.copy2(src_dir,des_dir)

def makeFile(typeOfGame):
    for i in range(1,28):
        desDir="H:\Programs\Steam\streaming\\"+typeOfGame+str(i) 
        if(not os.path.exists(desDir)):
            os.mkdir(desDir)
            return desDir

def saveStreamingFiles(typeOfGame,desDir):
    path =r'H:\Programs\Steam\streaming' #
    files = []
    if typeOfGame == "Geo": #Game
        typeOfGame="Geometry_Wars"  
    for i in os.listdir(path):
        if os.path.isfile(os.path.join(path,i)) and typeOfGame in i:
            files.append(i)
    for i in  files:
        src_dir = path+"\\"+i
        shutil.move(src_dir,desDir)

def main():
    #typeOfGame="Geo"
    #typeOfGame="SpeedRunners"
    typeOfGame="SOULCALIBUR"
    
    desDir = makeFile(typeOfGame)
    saveStreamingFiles(typeOfGame,desDir)
    saveFile(desDir)


if __name__ == "__main__":
    """ This is executed when run from the command line """
    main()
