"""
Module Docstring
This is for running the tests on the Client. It needs to be run as an administrator
and in the same directory as clumsy.exe. It will go thorugh scenarios
and apply the correct condtions in a random order and press F8 every 10 seconds to collect the Trace file. In order for it to
work steam remote setting needs to to be set to detailed, but you need to tab out
once in order to make the graph disappear.
"""

__author__ = "Markus Wetterberg, Sebastian Flinck Lindström"
__version__ = "0.0.1"

import time
from pynput.keyboard import Key, Controller
from datetime import datetime
import subprocess
import os
import signal
import msvcrt as m
import numpy as np

import ctypes
import time

SendInput = ctypes.windll.user32.SendInput

# C struct redefinitions 
PUL = ctypes.POINTER(ctypes.c_ulong)
class KeyBdInput(ctypes.Structure):
    _fields_ = [("wVk", ctypes.c_ushort),
                ("wScan", ctypes.c_ushort),
                ("dwFlags", ctypes.c_ulong),
                ("time", ctypes.c_ulong),
                ("dwExtraInfo", PUL)]

class HardwareInput(ctypes.Structure):
    _fields_ = [("uMsg", ctypes.c_ulong),
                ("wParamL", ctypes.c_short),
                ("wParamH", ctypes.c_ushort)]

class MouseInput(ctypes.Structure):
    _fields_ = [("dx", ctypes.c_long),
                ("dy", ctypes.c_long),
                ("mouseData", ctypes.c_ulong),
                ("dwFlags", ctypes.c_ulong),
                ("time",ctypes.c_ulong),
                ("dwExtraInfo", PUL)]

class Input_I(ctypes.Union):
    _fields_ = [("ki", KeyBdInput),
                 ("mi", MouseInput),
                 ("hi", HardwareInput)]

class Input(ctypes.Structure):
    _fields_ = [("type", ctypes.c_ulong),
                ("ii", Input_I)]

# Actuals Functions

def PressKey(hexKeyCode):
    extra = ctypes.c_ulong(0)
    ii_ = Input_I()
    ii_.ki = KeyBdInput( 0, hexKeyCode, 0x0008, 0, ctypes.pointer(extra) )
    x = Input( ctypes.c_ulong(1), ii_ )
    ctypes.windll.user32.SendInput(1, ctypes.pointer(x), ctypes.sizeof(x))

def ReleaseKey(hexKeyCode):
    extra = ctypes.c_ulong(0)
    ii_ = Input_I()
    ii_.ki = KeyBdInput( 0, hexKeyCode, 0x0008 | 0x0002, 0, ctypes.pointer(extra) )
    x = Input( ctypes.c_ulong(1), ii_ )
    ctypes.windll.user32.SendInput(1, ctypes.pointer(x), ctypes.sizeof(x))

# directx scan codes http://www.gamespp.com/directx/directInputKeyboardScanCodes.html

def main():
    """ Main entry point of the app """
    print("hello world")


def gameLoop():
    loop = True
    counter = 0
    keyboard = Controller()
    #keyboard.press(Key.f8)

	
    while loop:
        try:
            time.sleep(0.5)
            counter += 1
            if(counter == 19):
                PressKey(0x42)
                time.sleep(1)
                ReleaseKey(0x42)
                time.sleep(1)
                counter = 0
            #print("Looping")
        except KeyboardInterrupt:
            print("Finished Looping")
            loop = False


if __name__ == "__main__":

    f = open("testLog.txt", "a")
    """ This is executed when run from the command line """

    print("Starting test")
    
    
    testCounter = "BL1" 
    now = datetime.now()
    print("Starting scenario " + testCounter)
    #pid = subprocess.Popen("clumsy --drop on --drop-chance 1")    
    f.write("Scenario " + str(testCounter) +" started at " + now.strftime("%H:%M:%S") + "\n")
    gameLoop()
    now = datetime.now()
    f.write("Scenario " + str(testCounter) + " ended at " + now.strftime("%H:%M:%S")+"\n\n\n")
    #os.kill(pid.pid, signal.SIGTERM)
    print("Stäng ner streamen på laptop, skriv ner score och spara undan streamingLog.txt \nStarta sen streamen igen och tryck enter för att börja nästa test")
    input("")

    testCounter = "L1" 
    now = datetime.now()
    print("Starting scenario " + testCounter)
    pid = subprocess.Popen("clumsy --filter \"inbound\" --lag on --lag-time 25")    
    f.write("Scenario " + str(testCounter) +" started at " + now.strftime("%H:%M:%S") + "\n")
    gameLoop()
    now = datetime.now()
    f.write("Scenario " + str(testCounter) + " ended at " + now.strftime("%H:%M:%S")+"\n\n\n")
    os.kill(pid.pid, signal.SIGTERM)
    print("Stäng ner streamen på laptop, skriv ner score och spara undan streamingLog.txt \nStarta sen streamen igen och tryck enter för att börja nästa test")
    input("")

    testCounter = "L2" 
    now = datetime.now()
    print("Starting scenario " + testCounter)
    pid = subprocess.Popen("clumsy --filter \"inbound\" --lag on --lag-time 50")    
    f.write("Scenario " + str(testCounter) +" started at " + now.strftime("%H:%M:%S") + "\n")
    gameLoop()
    now = datetime.now()
    f.write("Scenario " + str(testCounter) + " ended at " + now.strftime("%H:%M:%S")+"\n\n\n")
    os.kill(pid.pid, signal.SIGTERM)
    print("Stäng ner streamen på laptop, skriv ner score och spara undan streamingLog.txt \nStarta sen streamen igen och tryck enter för att börja nästa test")
    input("")

    testCounter = "L3" 
    now = datetime.now()
    print("Starting scenario " + testCounter)
    pid = subprocess.Popen("clumsy --filter \"inbound\" --lag on --lag-time 75")    
    f.write("Scenario " + str(testCounter) +" started at " + now.strftime("%H:%M:%S") + "\n")
    gameLoop()
    now = datetime.now()
    f.write("Scenario " + str(testCounter) + " ended at " + now.strftime("%H:%M:%S")+"\n\n\n")
    os.kill(pid.pid, signal.SIGTERM)
    print("Stäng ner streamen på laptop, skriv ner score och spara undan streamingLog.txt \nStarta sen streamen igen och tryck enter för att börja nästa test")
    input("")

    testCounter = "L4" 
    now = datetime.now()
    print("Starting scenario " + testCounter)
    pid = subprocess.Popen("clumsy --filter \"inbound\" --lag on --lag-time 100")    
    f.write("Scenario " + str(testCounter) +" started at " + now.strftime("%H:%M:%S") + "\n")
    gameLoop()
    now = datetime.now()
    f.write("Scenario " + str(testCounter) + " ended at " + now.strftime("%H:%M:%S")+"\n\n\n")
    os.kill(pid.pid, signal.SIGTERM)
    print("Stäng ner streamen på laptop, skriv ner score och spara undan streamingLog.txt \nStarta sen streamen igen och tryck enter för att börja nästa test")
    input("")

    testCounter = "L5" 
    now = datetime.now()
    print("Starting scenario " + testCounter)
    pid = subprocess.Popen("clumsy --filter \"inbound\" --lag on --lag-time 125")    
    f.write("Scenario " + str(testCounter) +" started at " + now.strftime("%H:%M:%S") + "\n")
    gameLoop()
    now = datetime.now()
    f.write("Scenario " + str(testCounter) + " ended at " + now.strftime("%H:%M:%S")+"\n\n\n")
    os.kill(pid.pid, signal.SIGTERM)
    print("Stäng ner streamen på laptop, skriv ner score och spara undan streamingLog.txt \nStarta sen streamen igen och tryck enter för att börja nästa test")
    input("")

    testCounter = "L6" 
    now = datetime.now()
    print("Starting scenario " + testCounter)
    pid = subprocess.Popen("clumsy --filter \"inbound\" --lag on --lag-time 150")    
    f.write("Scenario " + str(testCounter) +" started at " + now.strftime("%H:%M:%S") + "\n")
    gameLoop()
    now = datetime.now()
    f.write("Scenario " + str(testCounter) + " ended at " + now.strftime("%H:%M:%S")+"\n\n\n")
    os.kill(pid.pid, signal.SIGTERM)
    print("Stäng ner streamen på laptop, skriv ner score och spara undan streamingLog.txt \nStarta sen streamen igen och tryck enter för att börja nästa test")
    input("")

    testCounter = "L7" 
    now = datetime.now()
    print("Starting scenario " + testCounter)
    pid = subprocess.Popen("clumsy --filter \"inbound\" --lag on --lag-time 175")    
    f.write("Scenario " + str(testCounter) +" started at " + now.strftime("%H:%M:%S") + "\n")
    gameLoop()
    now = datetime.now()
    f.write("Scenario " + str(testCounter) + " ended at " + now.strftime("%H:%M:%S")+"\n\n\n")
    os.kill(pid.pid, signal.SIGTERM)
    print("Stäng ner streamen på laptop, skriv ner score och spara undan streamingLog.txt \nStarta sen streamen igen och tryck enter för att börja nästa test")
    input("")

    testCounter = "L8" 
    now = datetime.now()
    print("Starting scenario " + testCounter)
    pid = subprocess.Popen("clumsy --filter \"inbound\" --lag on --lag-time 200")    
    f.write("Scenario " + str(testCounter) +" started at " + now.strftime("%H:%M:%S") + "\n")
    gameLoop()
    now = datetime.now()
    f.write("Scenario " + str(testCounter) + " ended at " + now.strftime("%H:%M:%S")+"\n\n\n")
    os.kill(pid.pid, signal.SIGTERM)
    print("Stäng ner streamen på laptop, skriv ner score och spara undan streamingLog.txt \nStarta sen streamen igen och tryck enter för att börja nästa test")
    input("")

    testCounter = "P1" 
    now = datetime.now()
    print("Starting scenario " + testCounter)
    pid = subprocess.Popen("clumsy --filter \"inbound\" --drop on --drop-chance 0.25")    
    f.write("Scenario " + str(testCounter) +" started at " + now.strftime("%H:%M:%S") + "\n")
    gameLoop()
    now = datetime.now()
    f.write("Scenario " + str(testCounter) + " ended at " + now.strftime("%H:%M:%S")+"\n\n\n")
    os.kill(pid.pid, signal.SIGTERM)
    print("Stäng ner streamen på laptop, skriv ner score och spara undan streamingLog.txt \nStarta sen streamen igen och tryck enter för att börja nästa test")
    input("")

    testCounter = "P2" 
    now = datetime.now()
    print("Starting scenario " + testCounter)
    pid = subprocess.Popen("clumsy --filter \"inbound\" --drop on --drop-chance 0.5")     
    f.write("Scenario " + str(testCounter) +" started at " + now.strftime("%H:%M:%S") + "\n")
    gameLoop()
    now = datetime.now()
    f.write("Scenario " + str(testCounter) + " ended at " + now.strftime("%H:%M:%S")+"\n\n\n")
    os.kill(pid.pid, signal.SIGTERM)
    print("Stäng ner streamen på laptop, skriv ner score och spara undan streamingLog.txt \nStarta sen streamen igen och tryck enter för att börja nästa test")
    input("")

    testCounter = "P3" 
    now = datetime.now()
    print("Starting scenario " + testCounter)
    pid = subprocess.Popen("clumsy --filter \"inbound\" --drop on --drop-chance 0.75")    
    f.write("Scenario " + str(testCounter) +" started at " + now.strftime("%H:%M:%S") + "\n")
    gameLoop()
    now = datetime.now()
    f.write("Scenario " + str(testCounter) + " ended at " + now.strftime("%H:%M:%S")+"\n\n\n")
    os.kill(pid.pid, signal.SIGTERM)
    print("Stäng ner streamen på laptop, skriv ner score och spara undan streamingLog.txt \nStarta sen streamen igen och tryck enter för att börja nästa test")
    input("")

    testCounter = "P4" 
    now = datetime.now()
    print("Starting scenario " + testCounter)
    pid = subprocess.Popen("clumsy --filter \"inbound\" --drop on --drop-chance 1")    
    f.write("Scenario " + str(testCounter) +" started at " + now.strftime("%H:%M:%S") + "\n")
    gameLoop()
    now = datetime.now()
    f.write("Scenario " + str(testCounter) + " ended at " + now.strftime("%H:%M:%S")+"\n\n\n")
    os.kill(pid.pid, signal.SIGTERM)
    print("Stäng ner streamen på laptop, skriv ner score och spara undan streamingLog.txt \nStarta sen streamen igen och tryck enter för att börja nästa test")
    input("")

    testCounter = "P5" 
    now = datetime.now()
    print("Starting scenario " + testCounter)
    pid = subprocess.Popen("clumsy --filter \"inbound\" --drop on --drop-chance 1.25")    
    f.write("Scenario " + str(testCounter) +" started at " + now.strftime("%H:%M:%S") + "\n")
    gameLoop()
    now = datetime.now()
    f.write("Scenario " + str(testCounter) + " ended at " + now.strftime("%H:%M:%S")+"\n\n\n")
    os.kill(pid.pid, signal.SIGTERM)
    print("Stäng ner streamen på laptop, skriv ner score och spara undan streamingLog.txt \nStarta sen streamen igen och tryck enter för att börja nästa test")
    input("")

    testCounter = "P6" 
    now = datetime.now()
    print("Starting scenario " + testCounter)
    pid = subprocess.Popen("clumsy --filter \"inbound\" --drop on --drop-chance 1.5")    
    f.write("Scenario " + str(testCounter) +" started at " + now.strftime("%H:%M:%S") + "\n")
    gameLoop()
    now = datetime.now()
    f.write("Scenario " + str(testCounter) + " ended at " + now.strftime("%H:%M:%S")+"\n\n\n")
    os.kill(pid.pid, signal.SIGTERM)
    print("Stäng ner streamen på laptop, skriv ner score och spara undan streamingLog.txt \nStarta sen streamen igen och tryck enter för att börja nästa test")
    input("")

    testCounter = "P7" 
    now = datetime.now()
    print("Starting scenario " + testCounter)
    pid = subprocess.Popen("clumsy --filter \"inbound\" --drop on --drop-chance 1.75")    
    f.write("Scenario " + str(testCounter) +" started at " + now.strftime("%H:%M:%S") + "\n")
    gameLoop()
    now = datetime.now()
    f.write("Scenario " + str(testCounter) + " ended at " + now.strftime("%H:%M:%S")+"\n\n\n")
    os.kill(pid.pid, signal.SIGTERM)
    print("Stäng ner streamen på laptop, skriv ner score och spara undan streamingLog.txt \nStarta sen streamen igen och tryck enter för att börja nästa test")
    input("")

    testCounter = "P8" 
    now = datetime.now()
    print("Starting scenario " + testCounter)
    pid = subprocess.Popen("clumsy --filter \"inbound\" --drop on --drop-chance 2")    
    f.write("Scenario " + str(testCounter) +" started at " + now.strftime("%H:%M:%S") + "\n")
    gameLoop()
    now = datetime.now()
    f.write("Scenario " + str(testCounter) + " ended at " + now.strftime("%H:%M:%S")+"\n\n\n")
    os.kill(pid.pid, signal.SIGTERM)
    print("Stäng ner streamen på laptop, skriv ner score och spara undan streamingLog.txt \nStarta sen streamen igen och tryck enter för att börja nästa test")
    input("")

    testCounter = "PL1" 
    now = datetime.now()
    print("Starting scenario " + testCounter)
    pid = subprocess.Popen("clumsy --filter \"inbound\" --drop on --drop-chance 0.5 --lag on --lag-time 50")    
    f.write("Scenario " + str(testCounter) +" started at " + now.strftime("%H:%M:%S") + "\n")
    gameLoop()
    now = datetime.now()
    f.write("Scenario " + str(testCounter) + " ended at " + now.strftime("%H:%M:%S")+"\n\n\n")
    os.kill(pid.pid, signal.SIGTERM)
    print("Stäng ner streamen på laptop, skriv ner score och spara undan streamingLog.txt \nStarta sen streamen igen och tryck enter för att börja nästa test")
    input("")

    testCounter = "PL2" 
    now = datetime.now()
    print("Starting scenario " + testCounter)
    pid = subprocess.Popen("clumsy --filter \"inbound\" --drop on --drop-chance 1 --lag on --lag-time 100")      
    f.write("Scenario " + str(testCounter) +" started at " + now.strftime("%H:%M:%S") + "\n")
    gameLoop()
    now = datetime.now()
    f.write("Scenario " + str(testCounter) + " ended at " + now.strftime("%H:%M:%S")+"\n\n\n")
    os.kill(pid.pid, signal.SIGTERM)
    print("Stäng ner streamen på laptop, skriv ner score och spara undan streamingLog.txt \nStarta sen streamen igen och tryck enter för att börja nästa test")
    input("")

    testCounter = "PL3" 
    now = datetime.now()
    print("Starting scenario " + testCounter)
    pid = subprocess.Popen("clumsy --filter \"inbound\" --drop on --drop-chance 1 --lag on --lag-time 150")      
    f.write("Scenario " + str(testCounter) +" started at " + now.strftime("%H:%M:%S") + "\n")
    gameLoop()
    now = datetime.now()
    f.write("Scenario " + str(testCounter) + " ended at " + now.strftime("%H:%M:%S")+"\n\n\n")
    os.kill(pid.pid, signal.SIGTERM)
    print("Stäng ner streamen på laptop, skriv ner score och spara undan streamingLog.txt \nStarta sen streamen igen och tryck enter för att börja nästa test")
    input("")

    testCounter = "PL4" 
    now = datetime.now()
    print("Starting scenario " + testCounter)
    pid = subprocess.Popen("clumsy --filter \"inbound\" --drop on --drop-chance 1 --lag on --lag-time 200")      
    f.write("Scenario " + str(testCounter) +" started at " + now.strftime("%H:%M:%S") + "\n")
    gameLoop()
    now = datetime.now()
    f.write("Scenario " + str(testCounter) + " ended at " + now.strftime("%H:%M:%S")+"\n\n\n")
    os.kill(pid.pid, signal.SIGTERM)
    print("Stäng ner streamen på laptop, skriv ner score och spara undan streamingLog.txt \nStarta sen streamen igen och tryck enter för att börja nästa test")
    input("")

    testCounter = "PL5" 
    now = datetime.now()
    print("Starting scenario " + testCounter)
    pid = subprocess.Popen("clumsy --filter \"inbound\" --drop on --drop-chance 1.5 --lag on --lag-time 100")      
    f.write("Scenario " + str(testCounter) +" started at " + now.strftime("%H:%M:%S") + "\n")
    gameLoop()
    now = datetime.now()
    f.write("Scenario " + str(testCounter) + " ended at " + now.strftime("%H:%M:%S")+"\n\n\n")
    os.kill(pid.pid, signal.SIGTERM)
    print("Stäng ner streamen på laptop, skriv ner score och spara undan streamingLog.txt \nStarta sen streamen igen och tryck enter för att börja nästa test")
    input("")

    testCounter = "PL6" 
    now = datetime.now()
    print("Starting scenario " + testCounter)
    pid = subprocess.Popen("clumsy --filter \"inbound\" --drop on --drop-chance 2 --lag on --lag-time 100")      
    f.write("Scenario " + str(testCounter) +" started at " + now.strftime("%H:%M:%S") + "\n")
    gameLoop()
    now = datetime.now()
    f.write("Scenario " + str(testCounter) + " ended at " + now.strftime("%H:%M:%S")+"\n\n\n")
    os.kill(pid.pid, signal.SIGTERM)
    
    
    f.write("Test finished")
    f.close()

    print("Döp om och spara undan testLog.txt")
